//
// Copyright (C) 2006 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**
 * @file Repository.h
 * @author Helge Backhaus
 */

#ifndef __REPOSITORY_H__
#define __REPOSITORY_H__

#include <omnetpp.h>
#include <myVector.h>
#include <NodeHandle.h>
#include <Vast.h>
#include <VastDefs.h>
#include <NeighborsList.h>

class Repository : public cSimpleModule
{
    public:
        virtual void initialize();
        virtual void handleMessage(cMessage* msg);
        virtual ~Repository();

        void setPosition_size(int size);
        int getPosition_size();
        Vector& getPosition(int k);
        void setPosition(int k, const Vector& Position);
        int getCounter();
        void setCounter(int Counter);

    protected:
        void testConnectivity(cTopology::Node *node);
        cTopology::Node* getNodeByHandle(NodeHandle nodeHandle);
        NeighborsList* neighborsList;

        // ptr to an vector array
        Vector *Position;
        int Position_size, Counter, testCounter;
        double connectivityCheckTimeout;

        // timers
        cMessage* check_timer;

        cTopology topology;
};

#endif
