//
// Copyright (C) 2006 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**
 * @file SimpleClient.h
 * @author Helge Backhaus
 */

#ifndef __SIMPLECLIENT_H_
#define __SIMPLECLIENT_H_

#include <map>
#include <myVector.h>
#include <BaseApp.h>

#include "Repository.h"
#include "MovementGenerator.h"
#include "randomRoaming.h"
#include "groupRoaming.h"
#include "greatGathering.h"
#include "Vast_m.h"

/// SimpleClient class
/**
 A simple test application, which simulates node movement based on different movement generators.
 */

class SimpleClient : public BaseApp
{
    public:
        // OMNeT++
        virtual ~SimpleClient();
        virtual void initializeApp(int stage);
        virtual void handleTimerEvent(cMessage* msg);
        virtual void handleAppMessage(cMessage* msg);

    protected:
        Repository* repository;

        void updateNeighbors(SimpleClientListMessage* scMsg);

        // parameters
        double moveDelay;
        Vector position;
        MovementGenerator *Generator;

        std::map<TransportAddress, Vector> Neighbors;
        std::map<TransportAddress, Vector>::iterator itNeighbors;

        // timers
        cMessage* move_timer;
};

#endif
