//
// Copyright (C) 2006 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**
 * @file myVector.h
 * @author Helge Backhaus
 */

#ifndef __MYVECTOR_H_
#define __MYVECTOR_H_

#include <math.h>
#include <iostream>

/// Vector class
/**
 A 2d vector.
 */

class Vector
{
    public:
        Vector();
        void normalize();
        void setValue(double x, double y);
        double distsqr(const Vector& v);
        double getX() { return x; }
        double getY() { return y; }
        void setX(double x) { this->x = x; }
        void setY(double y) { this->y = y; }

        Vector& operator=(const Vector& v);
        Vector& operator+=(const Vector& v);
        Vector& operator-=(const Vector& v);

        Vector operator+(const Vector& v);
        Vector operator-(const Vector& v);
        Vector operator*(const double s);

        bool operator==(const Vector& v);
        bool operator!=(const Vector& v);

        friend std::ostream& operator<<(std::ostream& Stream, const Vector v);

    protected:
        double x, y;
};

#endif
