//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef __BACKUPNODE_H_
#define __BACKUPNODE_H_


#include <vector>
#include <list>
#include <BasicModule.h>
#include <omnetpp.h>
#include "SubSpace.h"
#include "PlayerNode.h"
#include "LoadBalancingTree.h"

class Delay {
	public: 
	double delay;
	IPAddress ip;
	bool operator<(const Delay delay) const;

};

class BackupNodeData
 {
	public:
		BackupNodeData(SubSpace subSpace);
		SubSpace getSubSpace();
		void setSubSpace(SubSpace subSpace);
		int getId();
		double lastMessage;
		bool operator<(const BackupNodeData backupNode) const;
		friend std::ostream& operator<<(std::ostream& Stream, BackupNodeData b);
		void addDelay(double delay, IPAddress ip);
		Delay getMaxDelay();
		double getBackupDelay();
		void setBackupDelay(double delay);
		void setTree(std::list<TreeNode> tree);
		std::list<TreeNode> getTree();
		int getSize();
	protected:
		SubSpace subSpace;
		Delay lastMaxDelay;
		double backupDelay;
		int size;
		std::list<double>lastBackupDelays;
		std::list<double>::iterator lB;
		std::list<Delay> delays;
		std::list<TreeNode> tree;

};

#endif
