//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//


#include "IntermediateNodeData.h"


IntermediateNodeData::IntermediateNodeData(SubSpace subSpace) {
	this->subSpace = subSpace;
}

int IntermediateNodeData::getSubSpaceId() {
	return subSpace.getId();
}

std::list<IPAddress> IntermediateNodeData::getIps() {
	return ips;
}
int IntermediateNodeData::getSize() {
	return ips.size();
}
void IntermediateNodeData::addIp(IPAddress ip) {
	ips.push_back( ip) ;
}
void IntermediateNodeData::removeIp(IPAddress ip) {
	for( i = ips.begin(); i != ips.end(); ++i) {
		if( *i == ip) {
			ips.erase(i);
			break;
		}
	}
}
bool IntermediateNodeData::addDelay(double delay) {
	delays.push_back(delay);
	if(delays.size() > 3) return true;
	return false;
}
double IntermediateNodeData::getDelay() {
	double avg=0;
	if( delays.size() > 0 ) {
		std::list<double>::iterator i=delays.begin();
		while(i != delays.end() ) {
			avg += *i;
			++i;
		}
		avg = avg / delays.size();
		delays.clear();
	}
	return avg;
}
IPAddress IntermediateNodeData::getBackupIp() {
	return subSpace.getBackupIp();
}
void IntermediateNodeData::setBackupIp(IPAddress ip) {
	subSpace.setBackupIp(ip);
}
int IntermediateNodeData::getTimeSlot() {
	return subSpace.getTimeSlot();
}
void IntermediateNodeData::setTimeSlot(int timeSlot) {
	this->subSpace.setTimeSlot( timeSlot );
}
std::ostream& operator<<(std::ostream& Stream, IntermediateNodeData i)
{
    return Stream << "ID:" << i.subSpace.getId() << " Resp: " << i.subSpace.getRespIp() << " Backup " << i.subSpace.getBackupIp() << " We have " << i.ips.size() << " Leaf Ips";
}

