//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef __INTERMEDIATENODE_H_
#define __INTERMEDIATENODE_H_


#include <vector>
#include <list>
#include "IPAddress.h"
#include "SubSpace.h"

class IntermediateNodeData
 {
	public:
		IntermediateNodeData(SubSpace subSpace);
		int getSubSpaceId();
		std::list<IPAddress> getIps();
		IPAddress getBackupIp();
		void setBackupIp(IPAddress ip);
		int getTimeSlot();
		void setTimeSlot(int timeSlot);
		double getDelay();
		int getSize();
		bool addDelay(double delay);
		void addIp(IPAddress ip);
		void removeIp(IPAddress ip);
		friend std::ostream& operator<<(std::ostream& Stream, IntermediateNodeData r);

	protected:
		SubSpace subSpace;
		std::list<IPAddress> ips;
		std::list<IPAddress>::iterator i;
		std::list<double>delays;
		
};

#endif
