//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
#include "PlayerNode.h"

PlayerNode::PlayerNode() {
	//Dummy for .msg
}
PlayerNode::PlayerNode(IPAddress ip) {
	this->ip = ip;
}
PlayerNode::PlayerNode(int id, IPAddress ip, int Bandwith, int Cpu) {
	this->id = id;
	this->ip = ip;
	this->Bandwith = Bandwith;
	this->Cpu = Cpu;
}

int PlayerNode::getId() const {
	return id;
}
IPAddress PlayerNode::getIp() const {
	return ip;
}
int PlayerNode::getBandwith() const {
	return Bandwith;
}
int PlayerNode::getCpu() const {
	return Cpu;
}
void PlayerNode::modifyBandwith(int diff) {
	Bandwith += diff;
	if( Bandwith < 0 ) {
		Bandwith=0;
	}
}

bool PlayerNode::operator<(const PlayerNode player) const {
	if ( Bandwith > player.getBandwith() ) return true;
	return false;
}
std::ostream& operator<<(std::ostream& Stream, const PlayerNode p)
{
    return Stream << "PlayerId: " << p.getId() << " Bandwith: " << p.getBandwith() << " Cpu: " << p.getCpu() << " IP: " << p.getIp()<< "\n";
}


