//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef __PLAYERTABLE_H_
#define __PLAYERTABLE_H_

#include <vector>
#include <list>
#include <BasicModule.h>
#include <omnetpp.h>
#include "PlayerNode.h"
#include "SubSpaceTable.h"

class PlayerTable :public BasicModule
{
	public:
		virtual int numInitStages() const {return 6;}
		// OMNeT++
		virtual void initialize(int stage);
		virtual void finish();
		virtual void handleMessage(cMessage* msg);
		~PlayerTable();
		int add(int id, IPAddress ip, int Bandwith, int Cpu);
		bool remove(int id);
		void remove(IPAddress ip);
		int getSize();
		PlayerNode getHeadAndModify(int subSpaceId, IPAddress ip, int diff);
		PlayerNode* findPlayerNodeByIp(IPAddress playerIp);
		void modify(int subSpaceId, IPAddress playerIp,  int nodeType);
		
		std::list<PlayerNode> playerTable;
		std::list<PlayerNode>::iterator b;
		int player_autoincrement_id;
		std::list<PlayerNode*> nodeQueue;
		std::list<PlayerNode*>::iterator n;
		SubSpaceTable* subSpaceTable;

};

#endif
