//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//


#include <IPAddress.h>
#include "SubSpace.h"

SubSpace::SubSpace() {
}

SubSpace::SubSpace(int id) {
	this->id = id;
	this->resp_ip = (IPAddress) "127.0.0.1";
	this->backup_ip = (IPAddress) "127.0.0.1";
	for ( int i=0 ; i <= 7 ; i++ ) {
		neighbors[i] = (IPAddress) "127.0.0.1";
	}
	this->timeSlot = -1;
}

SubSpace::SubSpace(int id, IPAddress resp_ip) {
	this->id = id;
	this->resp_ip = resp_ip;
	this->backup_ip = (IPAddress) "127.0.0.1";
	for ( int i=0 ; i <= 7 ; i++ ) {
		neighbors[i] = (IPAddress) "127.0.0.1";
	}
	this->timeSlot = -1 ;
}

SubSpace::SubSpace(int id, IPAddress resp_ip, IPAddress backup_ip) {
	this->id = id;
	this->resp_ip = resp_ip;
	this->backup_ip = backup_ip;
	for ( int i=0 ; i <= 7 ; i++ ) {
		neighbors[i] = (IPAddress) "127.0.0.1";
	}
	this->timeSlot = -1;
}

int SubSpace::getTimeSlot() {
	return timeSlot;
}
void SubSpace::setTimeSlot(int timeSlot) {
	this->timeSlot = timeSlot;
}
int SubSpace::getId() const {
	return id;
}
void SubSpace::setId(int id) {
	this->id = id;
}
IPAddress SubSpace::getRespIp() const {
	return resp_ip;
}
void SubSpace::setRespIp(IPAddress resp_ip) {
	this->resp_ip = resp_ip;
}
IPAddress SubSpace::getBackupIp() const {
	return backup_ip;
}
void SubSpace::setBackupIp(IPAddress backup_ip) {
	this->backup_ip = backup_ip;
}
GameState SubSpace::getGameState() const {
	return gamestate;
}
void SubSpace::setGameState(GameState gamestate) {
	this->gamestate = gamestate;
}

void SubSpace::setNeighbor(int direction, IPAddress resp_ip) {
	if ( direction == -1 ) {
		this->backup_ip = resp_ip;
	} 
	else if( direction <= 8 ) {
		this->neighbors[direction] = resp_ip;
	}
}

IPAddress SubSpace::getNeighbor(int direction) const {
	if( direction <= 8 ) {
		return this->neighbors[direction];
	}
	return (IPAddress) "127.0.0.1";
}

std::ostream& operator<<(std::ostream& Stream, const SubSpace s)
{
    return Stream << "SubSpaceId: " << s.getId() << " : " << s.getRespIp() << " : " << s.getBackupIp() << "\n NW" << s.getNeighbor(NW) << " N " << s.getNeighbor(N) << " NE " << s.getNeighbor(NE) << "\n W " << s.getNeighbor(W) << "      E " << s.getNeighbor(E) << "\n SW:" << s.getNeighbor(SW) << " S " << s.getNeighbor(S) << " SE " << s.getNeighbor(SE) << "\n======================================\n";
}



