#include "pendingMessages.h"

std::ostream& operator<<(std::ostream& Stream, const OpenEvent openEvent)
{
    return Stream << "TimeStamp: " << openEvent.timeStamp << "SubSpaceId: " << openEvent.subSpaceId   << " Failed: " << openEvent.failed << " \n";
}
bool OpenEvent::operator<(const OpenEvent openEvent) const {
	if( timeStamp < openEvent.timeStamp ) {
		return true;
	}
	return false;
}

std::ostream& operator<<(std::ostream& Stream, const OpenSubscribe openSubscribe)
{
    return Stream << "TimeStamp: " << openSubscribe.timeStamp << "SubSpaceId: " << openSubscribe.subSpaceId << " RespIp: " << openSubscribe.destip << " Failed " << openSubscribe.failed << " \n";
}
bool OpenSubscribe::operator<(const OpenSubscribe openSubscribe) const {
	if( timeStamp < openSubscribe.timeStamp ) {
		return true;
	}
	return false;
}

std::ostream& operator<<(std::ostream& Stream, const OpenUnSubscribe openUnSubscribe)
{
    return Stream << "TimeStamp: " << openUnSubscribe.timeStamp << "SubSpaceId: " << openUnSubscribe.subSpaceId << " RespIp: " << openUnSubscribe.destip << " Failed " << openUnSubscribe.failed << " \n";
}
bool OpenUnSubscribe::operator<(const OpenUnSubscribe openUnSubscribe) const {
	if( timeStamp < openUnSubscribe.timeStamp ) {
		return true;
	}
	return false;
}

std::ostream& operator<<(std::ostream& Stream, const OpenLogin ol)
{
    return Stream << "TimeStamp: " << ol.timeStamp << "PlayerId: " << ol.playerid << " MissingSubSpaces: " << ol.missingSubSpaces.size() << "  Ready SubSpaces: " << ol.readySubSpaces.size() << "\n";
}

std::ostream& operator<<(std::ostream& Stream, const OpenCreate oc)
{
    return Stream << "TimeStamp: " << oc.timeStamp << "SubSpaceId: " << oc.subSpaceId << " DestIp: " << oc.destip << " NodeType " << oc.nodeType << " \n";
}
bool OpenLogin::operator<(const OpenLogin ologin) const {
	if( timeStamp < ologin.timeStamp ) {
		return true;
	}
	return false;
}
bool OpenCreate::operator<(const OpenCreate ocreate) const {
	if( timeStamp < ocreate.timeStamp ) {
		return true;
	}
	return false;
}
bool OpenRequestIp::operator<(const OpenRequestIp openRequest) const {
	if( timeStamp < openRequest.timeStamp ) {
		return true;
	}
	return false;
}

std::ostream& operator<<(std::ostream& Stream, const OpenRequestIp oc)
{
    return Stream << "TimeStamp: " << oc.timeStamp << "SubSpaceId: " << oc.subSpaceId << " DestIp: " << oc.destip << " NodeType " << oc.nodeType << " RequestedIp: " << oc.requestedIp << " \n";
}
bool OpenUpdateRespIp::operator<(const OpenUpdateRespIp openUpdate) const {
	if( timeStamp < openUpdate.timeStamp ) {
		return true;
	}
	return false;
}
std::ostream& operator<<(std::ostream& Stream, const OpenUpdateRespIp ou)
{
    return Stream << "TimeStamp: " << ou.timeStamp << "SubSpaceId: " << ou.subSpaceId << " Direction " << ou.direction << " DestIp: " << ou.destip << " NodeType " << ou.nodeType << " UpdatedIp: " << ou.updatedIp << " \n";
}
std::ostream& operator<<(std::ostream& Stream, const OpenPublishEventList ol)
{
    return Stream << "TimeStamp: " << ol.timeStamp << "SubSpaceId: " << ol.subSpaceId << " DestIp: " << ol.destip  << " Failed: " << ol.failed << " \n";
}

bool OpenPublishEventList::operator<(const OpenPublishEventList openPublish) const {
	if( timeStamp < openPublish.timeStamp ) {
		return true;
	}
	return false;
}

std::ostream& operator<<(std::ostream& Stream, const OpenPing op)
{
    return Stream << "TimeStamp: " << op.timeStamp <<  " DestIp: " << op.destip  << " Failed: " << op.failed << " \n";
}

bool OpenPing::operator<(const OpenPing openPing) const {
	if( timeStamp < openPing.timeStamp ) {
		return true;
	}
	return false;
}
std::ostream& operator<<(std::ostream& Stream, const OpenPlayerList op)
{
    return Stream << "TimeStamp: " << op.timeStamp << " SubSpaceId: " << op.subSpaceId  << " Failed: " << op.failed << " \n";
}

bool OpenPlayerList::operator<(const OpenPlayerList openPlayerList) const {
	if( timeStamp < openPlayerList.timeStamp ) {
		return true;
	}
	return false;
}

std::ostream& operator<<(std::ostream& Stream, const OpenRequestNode orn)
{
    return Stream << "TimeStamp: " << orn.timeStamp << " SubSpaceId: " << orn.subSpaceId  << " NodeType "<< orn.nodeType << " Failed: " << orn.failed << " \n";
}

bool OpenRequestNode::operator<(const OpenRequestNode openRequestNode) const {
	if( timeStamp < openRequestNode.timeStamp ) {
		return true;
	}
	return false;
}

std::ostream& operator<<(std::ostream& Stream, const OpenReplacement openReplacement)
{
    return Stream << "TimeStamp: " << openReplacement.timeStamp << " SubSpaceId: " << openReplacement.subSpaceId  << " Destip: " << openReplacement.destip << " senGamestate "<< openReplacement.sendGameState << " Failed: " << openReplacement.failed << " \n";
}

bool OpenReplacement::operator<(const OpenReplacement openReplacement) const {
	if( timeStamp < openReplacement.timeStamp ) {
		return true;
	}
	return false;
}
